\subsection{Module 10 - Managing Resource Consumption}

\subsubsection{Tagging}
A tag is a label that you assign to an AWS resource to enable you to identify it or categorize it in a meaningful way. A tag consists of a key and a value, which you define. 

Characteristics:
\begin{itemize}
	\item You can only assign a tag to a resource after it has been created
	\item Tag keys and values are case-sensitive. A best practice is to use a consistent standardized format.
	\item You cannot edit or delete tag keys or values with the aws: prefix. These tags are assigned by AWS and are reserved for AWS use. 
	\item Tags are sometimes inherited or propagated. Some services, such as Auto Scaling, AWS CloudFormation, and AWS Elastic Beanstalk can create other resources, such as Amazon Relational Database (Amazon RDS) or Amazon EC2 instances.
	\item You can only create up to 50 tags per resource. Tags with the aws: prefix do not count against this limit.
\end{itemize}

\subsubsection{Cost Management Tools}
One of the fundamental benefits of cloud computing is that you pay only for what you need, when you need it. This principle motivates you to look for ways to use your cloud resources efficiently and reduce cost.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{awscostmanagement}
  \caption{AWS Cost Management Tools}
\end{figure}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{costreduction}
  \caption{AWS Cost Reduction}
\end{figure}

\paragraph{Stopinator Script}
Writing and using a stopinator script is a technique for automating the shutdown of instances. A stopinator is a generic term for any script or application written against the AWS platform that looks for and stops unused instances. These scripts are typically set up to run during the evenings and on weekends. Employing a stopinator can result in significant cost savings to an organization, thus freeing up your cloud computing budget for new projects. 

\subsubsection{Trusted Advisor}
AWSTrusted Advisor is an online resource to help you reduce cost, increase performance, and improve security by optimizing your AWS environment. Trusted Advisor scans your AWS environment and compares it to more than 50 AWS best practices in five categories, and provides recommended actions. Recommendations include links to take direct action.


\subsection{Module 11 - Creating Automated and Repeatable Deployments}

\subsubsection{Configuration Management in the Cloud}
Amazon Web Services (AWS) offers several methods to help configure and manage infrastructure that is deployed on the AWS Cloud. It is important to plan the configuration and orchestration of AWS resourcesproactively instead of reactively. 

\paragraph{Technologies for Configuring EC2}
AWS provides a number of technologies for configuringand deploying your Amazon EC2 instances and other AWS infrastructure. 

\begin{description}
	\item [User Data] Enables you to author scripts that are run on instance launch. 
	\item [Amazon Machine Images (AMI)] By creating base images that are customized to the needs of your organization, you can pre-bake installations and configurations into the EC2 instances that are launched from the AMI, which can potentially reduce deployment times.
	\item [Configuration and deployment Frameworks] Such as Chef, Puppet, and Ansible. These technologies allow you to configure new instances by using reusable templates, and update configurations dynamically in response to change.
	\item [AWS OpsWorks] A configuration management service that provides managed instances of Chef and Puppet.
	\item [AWS CloudFormation] An AWS service that enables you to configure architectures for repeatable deployments.
\end{description}

\subsubsection{Using Configuration Software}
One of the advantages of using a configuration server (such as Chef, Puppet, or Ansible) is that configuration is idempotent. Resources that are created or configured by a configuration server are configured or created once, and only once.

\paragraph{Custom AMIs}
Consider the situation where your organization has requested that all EC2 instances launched in the AWS Cloud should have a base set of software pre-installed on them. This might include utilities developed by the organization, in-house tools for using AWS services, and advanced software for enterprise-scale activities, such as monitoring and intrusion detection. 

Given such requirements, you might want to consider developing one or more custom AMIs as a base configuration. To accomplish this task, you first launch an EC2 instance from a standard AMI, pre-configure all of the software that your organization requires on an Amazon EC2 instance, and then create a custom AMI from that instance. The new custom AMI then becomes the AMI that is used to create all new instances within the organization.

\subsubsection{Amazon EC2 Launch Templates}
Launch templates enable you to create templates for your launch requests. When you create a launch template, the following details can be specified ahead of time:
\begin{itemize}
	\item Instance type
	\item Subnet to launch the instance to
	\item The key pair to assign
	\item The security group to apply
\end{itemize}

For each launch template, you can create one or more numbered launch template versions. Each version can have different launch parameters.

\subsubsection{Infrastructure as Code}
The stages of the lifecycle are:
\begin{enumerate}
	\item Resource provisioning. Administrators provision resources according to business needs.
	\item Configuration management. The resources become components of a configuration management system that supports activities, such as upgrades, tuning, and patching.
	\item Monitoring and performance. Monitoring and performance tools validate the operational status of the resources, examining metrics, transactions, and log files.
	\item Compliance and governance. Compliance and governance frameworks ensure alignment with standards and regulatory requirements.
	\item Resource optimization. Administrators review performance data and identify changes that are needed to optimize the environment around criteria such as performance and cost management.
\end{enumerate}

Each stage involves procedures that can use code, which extends the benefits of infrastructure as code—from its traditional role of only provisioning resources—to now managing the entire resource lifecycle. Every part of the lifecycle benefits from the consistency and repeatability that the infrastructure as code approach offers.

\subsubsection{Introduction to JSON and YAML}

\paragraph{JSON}
\begin{minipage}{0.5\textwidth}
	\textbf{Advantages}
	\begin{itemize}
		\item Lightweight (minimal syntax and mockup)
		\item Easy for humans to read and write
		\item Easy for machines to parse and generate
	\end{itemize}
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\textbf{Disadvantages}
	\begin{itemize}
		\item Not tabular, so it is more difficult to read
		\item No native support for binary data (image files)
	\end{itemize}
\end{minipage}

\paragraph{YAML}
Compared to JSON, YAML is optimized for readability. It is less verbose than JSON. The same data that is stored in JSON will take fewer lines to store in YAML because YAML does not use curly braces, and it uses fewer quotation marks. Another advantage of YAML is that it natively supports embedded comments. Finally, many people find it easier to debug YAML documents compared with JSON. With JSON, it can be difficult to track down missing or misplaced commas or curly braces. YAML does not have this issue.

\textbf{Advatages} \hfill \\
\begin{itemize}
	\item Optimized for readability
	\item Less verbose than JSON, no curly braces
	\item Supports embedded comments
	\item Many people find it easier to debug
\end{itemize}

\subsubsection{Cloud Formation}
You can use a variety of technologies and tools for managing automated and repeatable deployments.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{deployments}
  \caption{Technologies for automated Deplyoments}
\end{figure}

\subsubsection{CI/CD on AWS}
Nearly all software release processes can be thought of as consisting of four basic stages—code, build, test, and deploy. Each phase provides increased confidence that the code being made available to customers will function as intended.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{cicd}
  \caption{Release Process Phases}
\end{figure}

With non-continuous integration and continuous deployment approaches, the build, test, and release process involves a lot of manual work, which can take significant time and introduce unnecessary delays. For example, developers might use tickets or emails to track a release process

\paragraph{AWS CodePipeline}
Features:
\begin{itemize}
	\item Continuous delivery service for fast and reliable application updates
	\item Model and visualize your software release process
	\item Build, test, and deploy your code every time there is a code change
	\item Integrate with third-party tools and AWS
\end{itemize}

